function GetOciTopLevelCommand_devops() {
    return 'devops'
}

function GetOciSubcommands_devops() {
    $ociSubcommands = @{
        'devops' = 'deploy-artifact deploy-environment deploy-pipeline deploy-stage deployment project work-request work-request-error work-request-log'
        'devops deploy-artifact' = 'create-generic-artifact create-inline-artifact create-ocir-artifact delete get list update update-generic-artifact update-inline-artifact update-ocir-artifact'
        'devops deploy-environment' = 'create-compute-instance-environment create-function-environment create-oke-cluster-environment delete get list update update-compute-instance-environment update-function-environment update-oke-cluster-environment'
        'devops deploy-pipeline' = 'create delete get list update'
        'devops deploy-stage' = 'create-deploy-compute-instance-group-stage create-deploy-function-stage create-deploy-oke-stage create-invoke-function-stage create-load-balancer-traffic-shift-stage create-manual-approval-stage create-wait-stage delete get list update update-deploy-compute-instance-group-stage update-deploy-function-stage update-deploy-oke-stage update-invoke-function-stage update-load-balancer-traffic-shift-stage update-manual-approval-stage update-wait-stage'
        'devops deployment' = 'approve cancel create-pipeline-deployment create-pipeline-redeployment create-single-stage-deployment get list update'
        'devops project' = 'change-compartment create delete get list update'
        'devops work-request' = 'get list'
        'devops work-request-error' = 'list'
        'devops work-request-log' = 'list'
    }
    return $ociSubcommands
}

function GetOciCommandsToLongParams_devops() {
    $ociCommandsToLongParams = @{
        'devops deploy-artifact create-generic-artifact' = 'argument-substitution-mode artifact-path artifact-type artifact-version defined-tags description display-name freeform-tags from-json help max-wait-seconds project-id repository-id wait-for-state wait-interval-seconds'
        'devops deploy-artifact create-inline-artifact' = 'argument-substitution-mode artifact-type base64-encoded-content defined-tags description display-name freeform-tags from-json help max-wait-seconds project-id wait-for-state wait-interval-seconds'
        'devops deploy-artifact create-ocir-artifact' = 'argument-substitution-mode artifact-type defined-tags description display-name freeform-tags from-json help image-digest max-wait-seconds project-id source-image-uri wait-for-state wait-interval-seconds'
        'devops deploy-artifact delete' = 'artifact-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'devops deploy-artifact get' = 'artifact-id from-json help'
        'devops deploy-artifact list' = 'all compartment-id display-name from-json help id lifecycle-state limit page page-size project-id sort-by sort-order'
        'devops deploy-artifact update' = 'argument-substitution-mode artifact-id artifact-type defined-tags description display-name force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'devops deploy-artifact update-generic-artifact' = 'argument-substitution-mode artifact-id artifact-path artifact-type artifact-version defined-tags description display-name force freeform-tags from-json help if-match max-wait-seconds repository-id wait-for-state wait-interval-seconds'
        'devops deploy-artifact update-inline-artifact' = 'argument-substitution-mode artifact-id artifact-type base64-encoded-content defined-tags description display-name force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'devops deploy-artifact update-ocir-artifact' = 'argument-substitution-mode artifact-id defined-tags description display-name force freeform-tags from-json help if-match image-digest max-wait-seconds source-image-uri wait-for-state wait-interval-seconds'
        'devops deploy-environment create-compute-instance-environment' = 'compute-instance-group-selectors defined-tags description display-name freeform-tags from-json help max-wait-seconds project-id wait-for-state wait-interval-seconds'
        'devops deploy-environment create-function-environment' = 'defined-tags description display-name freeform-tags from-json function-id help max-wait-seconds project-id wait-for-state wait-interval-seconds'
        'devops deploy-environment create-oke-cluster-environment' = 'cluster-id defined-tags description display-name freeform-tags from-json help max-wait-seconds project-id wait-for-state wait-interval-seconds'
        'devops deploy-environment delete' = 'environment-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'devops deploy-environment get' = 'environment-id from-json help'
        'devops deploy-environment list' = 'all compartment-id display-name from-json help id lifecycle-state limit page page-size project-id sort-by sort-order'
        'devops deploy-environment update' = 'defined-tags description display-name environment-id force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'devops deploy-environment update-compute-instance-environment' = 'compute-instance-group-selectors defined-tags description display-name environment-id force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'devops deploy-environment update-function-environment' = 'defined-tags description display-name environment-id force freeform-tags from-json function-id help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'devops deploy-environment update-oke-cluster-environment' = 'cluster-id defined-tags description display-name environment-id force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'devops deploy-pipeline create' = 'defined-tags description display-name freeform-tags from-json help max-wait-seconds pipeline-parameters project-id wait-for-state wait-interval-seconds'
        'devops deploy-pipeline delete' = 'force from-json help if-match max-wait-seconds pipeline-id wait-for-state wait-interval-seconds'
        'devops deploy-pipeline get' = 'from-json help pipeline-id'
        'devops deploy-pipeline list' = 'all compartment-id display-name from-json help id lifecycle-state limit page page-size project-id sort-by sort-order'
        'devops deploy-pipeline update' = 'defined-tags description display-name force freeform-tags from-json help if-match max-wait-seconds pipeline-id pipeline-parameters wait-for-state wait-interval-seconds'
        'devops deploy-stage create-deploy-compute-instance-group-stage' = 'artifact-ids compute-instance-group-environment-id defined-tags deployment-spec-artifact-id description display-name failure-policy freeform-tags from-json help load-balancer-config max-wait-seconds pipeline-id rollback-policy rollout-policy stage-predecessor-collection wait-for-state wait-interval-seconds'
        'devops deploy-stage create-deploy-function-stage' = 'config defined-tags description display-name docker-image-artifact-id freeform-tags from-json function-environment-id function-timeout-in-seconds help max-memory-in-mbs max-wait-seconds pipeline-id stage-predecessor-collection wait-for-state wait-interval-seconds'
        'devops deploy-stage create-deploy-oke-stage' = 'defined-tags description display-name freeform-tags from-json help kubernetes-manifest-artifact-ids max-wait-seconds namespace oke-cluster-environment-id pipeline-id rollback-policy stage-predecessor-collection wait-for-state wait-interval-seconds'
        'devops deploy-stage create-invoke-function-stage' = 'artifact-id defined-tags description display-name freeform-tags from-json function-environment-id help is-async is-validation-enabled max-wait-seconds pipeline-id stage-predecessor-collection wait-for-state wait-interval-seconds'
        'devops deploy-stage create-load-balancer-traffic-shift-stage' = 'blue-backend-ips defined-tags description display-name freeform-tags from-json green-backend-ips help load-balancer-config max-wait-seconds pipeline-id rollback-policy rollout-policy stage-predecessor-collection traffic-shift-target wait-for-state wait-interval-seconds'
        'devops deploy-stage create-manual-approval-stage' = 'approval-policy defined-tags description display-name freeform-tags from-json help max-wait-seconds pipeline-id stage-predecessor-collection wait-for-state wait-interval-seconds'
        'devops deploy-stage create-wait-stage' = 'defined-tags description display-name freeform-tags from-json help max-wait-seconds pipeline-id stage-predecessor-collection wait-criteria wait-for-state wait-interval-seconds'
        'devops deploy-stage delete' = 'force from-json help if-match max-wait-seconds stage-id wait-for-state wait-interval-seconds'
        'devops deploy-stage get' = 'from-json help stage-id'
        'devops deploy-stage list' = 'all compartment-id display-name from-json help id lifecycle-state limit page page-size pipeline-id sort-by sort-order'
        'devops deploy-stage update' = 'defined-tags description display-name force freeform-tags from-json help if-match max-wait-seconds stage-id stage-predecessor-collection wait-for-state wait-interval-seconds'
        'devops deploy-stage update-deploy-compute-instance-group-stage' = 'artifact-ids compute-instance-group-environment-id defined-tags deployment-spec-artifact-id description display-name failure-policy force freeform-tags from-json help if-match load-balancer-config max-wait-seconds rollback-policy rollout-policy stage-id stage-predecessor-collection wait-for-state wait-interval-seconds'
        'devops deploy-stage update-deploy-function-stage' = 'config defined-tags description display-name docker-image-artifact-id force freeform-tags from-json function-environment-id function-timeout-in-seconds help if-match max-memory-in-mbs max-wait-seconds stage-id stage-predecessor-collection wait-for-state wait-interval-seconds'
        'devops deploy-stage update-deploy-oke-stage' = 'defined-tags description display-name force freeform-tags from-json help if-match kubernetes-manifest-artifact-ids max-wait-seconds namespace oke-cluster-environment-id rollback-policy stage-id stage-predecessor-collection wait-for-state wait-interval-seconds'
        'devops deploy-stage update-invoke-function-stage' = 'artifact-id defined-tags description display-name force freeform-tags from-json function-environment-id help if-match is-async is-validation-enabled max-wait-seconds stage-id stage-predecessor-collection wait-for-state wait-interval-seconds'
        'devops deploy-stage update-load-balancer-traffic-shift-stage' = 'blue-backend-ips defined-tags description display-name force freeform-tags from-json green-backend-ips help if-match load-balancer-config max-wait-seconds rollback-policy rollout-policy stage-id stage-predecessor-collection traffic-shift-target wait-for-state wait-interval-seconds'
        'devops deploy-stage update-manual-approval-stage' = 'approval-policy defined-tags description display-name force freeform-tags from-json help if-match max-wait-seconds stage-id stage-predecessor-collection wait-for-state wait-interval-seconds'
        'devops deploy-stage update-wait-stage' = 'defined-tags description display-name force freeform-tags from-json help if-match max-wait-seconds stage-id stage-predecessor-collection wait-criteria wait-for-state wait-interval-seconds'
        'devops deployment approve' = 'action deployment-id from-json help if-match max-wait-seconds reason stage-id wait-for-state wait-interval-seconds'
        'devops deployment cancel' = 'deployment-id from-json help if-match max-wait-seconds reason wait-for-state wait-interval-seconds'
        'devops deployment create-pipeline-deployment' = 'artifact-override-arguments defined-tags deployment-arguments display-name freeform-tags from-json help max-wait-seconds pipeline-id wait-for-state wait-interval-seconds'
        'devops deployment create-pipeline-redeployment' = 'defined-tags deployment-id display-name freeform-tags from-json help max-wait-seconds previous-deployment-id wait-for-state wait-interval-seconds'
        'devops deployment create-single-stage-deployment' = 'artifact-override-arguments defined-tags deployment-arguments display-name freeform-tags from-json help max-wait-seconds pipeline-id stage-id wait-for-state wait-interval-seconds'
        'devops deployment get' = 'deployment-id from-json help'
        'devops deployment list' = 'all compartment-id display-name from-json help id lifecycle-state limit page page-size pipeline-id project-id sort-by sort-order time-created-greater-than-or-equal-to time-created-less-than'
        'devops deployment update' = 'defined-tags deployment-id display-name force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'devops project change-compartment' = 'compartment-id from-json help if-match max-wait-seconds project-id wait-for-state wait-interval-seconds'
        'devops project create' = 'compartment-id defined-tags description freeform-tags from-json help max-wait-seconds name notification-config wait-for-state wait-interval-seconds'
        'devops project delete' = 'force from-json help if-match max-wait-seconds project-id wait-for-state wait-interval-seconds'
        'devops project get' = 'from-json help project-id'
        'devops project list' = 'all compartment-id from-json help id lifecycle-state limit name page page-size sort-by sort-order'
        'devops project update' = 'defined-tags description force freeform-tags from-json help if-match max-wait-seconds notification-config project-id wait-for-state wait-interval-seconds'
        'devops work-request get' = 'from-json help work-request-id'
        'devops work-request list' = 'all compartment-id from-json help limit page page-size resource-id sort-by sort-order status work-request-id'
        'devops work-request-error list' = 'all from-json help limit page page-size sort-by sort-order work-request-id'
        'devops work-request-log list' = 'all from-json help limit page page-size sort-by sort-order work-request-id'
    }
    return $ociCommandsToLongParams
}

function GetOciCommandsToShortParams_devops() {
    $ociCommandsToShortParams = @{
        'devops deploy-artifact create-generic-artifact' = '? h'
        'devops deploy-artifact create-inline-artifact' = '? h'
        'devops deploy-artifact create-ocir-artifact' = '? h'
        'devops deploy-artifact delete' = '? h'
        'devops deploy-artifact get' = '? h'
        'devops deploy-artifact list' = '? c h'
        'devops deploy-artifact update' = '? h'
        'devops deploy-artifact update-generic-artifact' = '? h'
        'devops deploy-artifact update-inline-artifact' = '? h'
        'devops deploy-artifact update-ocir-artifact' = '? h'
        'devops deploy-environment create-compute-instance-environment' = '? h'
        'devops deploy-environment create-function-environment' = '? h'
        'devops deploy-environment create-oke-cluster-environment' = '? h'
        'devops deploy-environment delete' = '? h'
        'devops deploy-environment get' = '? h'
        'devops deploy-environment list' = '? c h'
        'devops deploy-environment update' = '? h'
        'devops deploy-environment update-compute-instance-environment' = '? h'
        'devops deploy-environment update-function-environment' = '? h'
        'devops deploy-environment update-oke-cluster-environment' = '? h'
        'devops deploy-pipeline create' = '? h'
        'devops deploy-pipeline delete' = '? h'
        'devops deploy-pipeline get' = '? h'
        'devops deploy-pipeline list' = '? c h'
        'devops deploy-pipeline update' = '? h'
        'devops deploy-stage create-deploy-compute-instance-group-stage' = '? h'
        'devops deploy-stage create-deploy-function-stage' = '? h'
        'devops deploy-stage create-deploy-oke-stage' = '? h'
        'devops deploy-stage create-invoke-function-stage' = '? h'
        'devops deploy-stage create-load-balancer-traffic-shift-stage' = '? h'
        'devops deploy-stage create-manual-approval-stage' = '? h'
        'devops deploy-stage create-wait-stage' = '? h'
        'devops deploy-stage delete' = '? h'
        'devops deploy-stage get' = '? h'
        'devops deploy-stage list' = '? c h'
        'devops deploy-stage update' = '? h'
        'devops deploy-stage update-deploy-compute-instance-group-stage' = '? h'
        'devops deploy-stage update-deploy-function-stage' = '? h'
        'devops deploy-stage update-deploy-oke-stage' = '? h'
        'devops deploy-stage update-invoke-function-stage' = '? h'
        'devops deploy-stage update-load-balancer-traffic-shift-stage' = '? h'
        'devops deploy-stage update-manual-approval-stage' = '? h'
        'devops deploy-stage update-wait-stage' = '? h'
        'devops deployment approve' = '? h'
        'devops deployment cancel' = '? h'
        'devops deployment create-pipeline-deployment' = '? h'
        'devops deployment create-pipeline-redeployment' = '? h'
        'devops deployment create-single-stage-deployment' = '? h'
        'devops deployment get' = '? h'
        'devops deployment list' = '? c h'
        'devops deployment update' = '? h'
        'devops project change-compartment' = '? c h'
        'devops project create' = '? c h'
        'devops project delete' = '? h'
        'devops project get' = '? h'
        'devops project list' = '? c h'
        'devops project update' = '? h'
        'devops work-request get' = '? h'
        'devops work-request list' = '? c h'
        'devops work-request-error list' = '? h'
        'devops work-request-log list' = '? h'
    }
    return $ociCommandsToShortParams
}