function GetOciTopLevelCommand_opsi() {
    return 'opsi'
}

function GetOciSubcommands_opsi() {
    $ociSubcommands = @{
        'opsi' = 'database-insights enterprise-manager-bridges host-insights work-requests'
        'opsi database-insights' = 'change create-em-external-db delete disable enable-em-external-db get ingest-database-configuration ingest-sql-bucket ingest-sql-plan-lines ingest-sql-text list list-database-configurations list-sql-plans list-sql-searches list-sql-texts summarize-database-insight-resource-capacity-trend summarize-database-insight-resource-forecast-trend summarize-database-insight-resource-statistics summarize-database-insight-resource-usage summarize-database-insight-resource-usage-trend summarize-database-insight-resource-utilization-insight summarize-database-insight-tablespace-usage-trend summarize-sql-insights summarize-sql-plan-insights summarize-sql-response-time-distributions summarize-sql-statistics summarize-sql-statistics-time-series summarize-sql-statistics-time-series-by-plan update-autonomous-db update-em-external-db update-macs-external-db'
        'opsi enterprise-manager-bridges' = 'change create delete get list list-importable-enterprise-manager-entities update'
        'opsi host-insights' = 'change create-macs-external-host delete disable enable-macs-external-host get ingest-host-configuration ingest-host-metrics list list-hosted-entities summarize-host-insight-resource-capacity-trend summarize-host-insight-resource-forecast-trend summarize-host-insight-resource-statistics summarize-host-insight-resource-usage summarize-host-insight-resource-usage-trend summarize-host-insight-resource-utilization-insight update-macs-external-host'
        'opsi work-requests' = 'get list'
    }
    return $ociSubcommands
}

function GetOciCommandsToLongParams_opsi() {
    $ociCommandsToLongParams = @{
        'opsi database-insights change' = 'compartment-id database-insight-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi database-insights create-em-external-db' = 'compartment-id defined-tags em-bridge-id em-entity-id em-id freeform-tags from-json help max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi database-insights delete' = 'database-insight-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi database-insights disable' = 'database-insight-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi database-insights enable-em-external-db' = 'database-insight-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi database-insights get' = 'database-insight-id from-json help'
        'opsi database-insights ingest-database-configuration' = 'database-id from-json help id if-match items'
        'opsi database-insights ingest-sql-bucket' = 'compartment-id database-id from-json help id if-match items'
        'opsi database-insights ingest-sql-plan-lines' = 'compartment-id database-id from-json help id if-match items'
        'opsi database-insights ingest-sql-text' = 'compartment-id database-id from-json help id if-match items'
        'opsi database-insights list' = 'all compartment-id database-id database-type em-bridge-id fields from-json help id lifecycle-state limit page page-size sort-by sort-order status'
        'opsi database-insights list-database-configurations' = 'all compartment-id database-id database-type defined-tag-equals defined-tag-exists em-bridge-id freeform-tag-equals freeform-tag-exists from-json help host-name id limit page page-size sort-by sort-order'
        'opsi database-insights list-sql-plans' = 'all compartment-id database-id from-json help id page plan-hash sql-identifier'
        'opsi database-insights list-sql-searches' = 'all analysis-time-interval compartment-id defined-tag-equals defined-tag-exists freeform-tag-equals freeform-tag-exists from-json help page sql-identifier time-interval-end time-interval-start'
        'opsi database-insights list-sql-texts' = 'all compartment-id database-id defined-tag-equals defined-tag-exists freeform-tag-equals freeform-tag-exists from-json help id page sql-identifier'
        'opsi database-insights summarize-database-insight-resource-capacity-trend' = 'analysis-time-interval compartment-id database-id database-type defined-tag-equals defined-tag-exists freeform-tag-equals freeform-tag-exists from-json help host-name id is-database-instance-level-metrics page resource-metric sort-by sort-order tablespace-name time-interval-end time-interval-start utilization-level'
        'opsi database-insights summarize-database-insight-resource-forecast-trend' = 'analysis-time-interval compartment-id confidence database-id database-type defined-tag-equals defined-tag-exists forecast-days forecast-model freeform-tag-equals freeform-tag-exists from-json help host-name id is-database-instance-level-metrics page resource-metric statistic tablespace-name time-interval-end time-interval-start utilization-level'
        'opsi database-insights summarize-database-insight-resource-statistics' = 'analysis-time-interval compartment-id database-id database-type defined-tag-equals defined-tag-exists forecast-days freeform-tag-equals freeform-tag-exists from-json help host-name id insight-by is-database-instance-level-metrics limit page percentile resource-metric sort-by sort-order time-interval-end time-interval-start'
        'opsi database-insights summarize-database-insight-resource-usage' = 'analysis-time-interval compartment-id database-id database-type defined-tag-equals defined-tag-exists freeform-tag-equals freeform-tag-exists from-json help host-name id is-database-instance-level-metrics page percentile resource-metric time-interval-end time-interval-start'
        'opsi database-insights summarize-database-insight-resource-usage-trend' = 'analysis-time-interval compartment-id database-id database-type defined-tag-equals defined-tag-exists freeform-tag-equals freeform-tag-exists from-json help host-name id is-database-instance-level-metrics page resource-metric sort-by sort-order time-interval-end time-interval-start'
        'opsi database-insights summarize-database-insight-resource-utilization-insight' = 'analysis-time-interval compartment-id database-id database-type defined-tag-equals defined-tag-exists forecast-days freeform-tag-equals freeform-tag-exists from-json help host-name id is-database-instance-level-metrics page resource-metric time-interval-end time-interval-start'
        'opsi database-insights summarize-database-insight-tablespace-usage-trend' = 'analysis-time-interval compartment-id database-id from-json help id limit page time-interval-end time-interval-start'
        'opsi database-insights summarize-sql-insights' = 'analysis-time-interval compartment-id database-id database-time-pct-greater-than database-type defined-tag-equals defined-tag-exists freeform-tag-equals freeform-tag-exists from-json help host-name id page time-interval-end time-interval-start'
        'opsi database-insights summarize-sql-plan-insights' = 'analysis-time-interval compartment-id database-id from-json help id page sql-identifier time-interval-end time-interval-start'
        'opsi database-insights summarize-sql-response-time-distributions' = 'analysis-time-interval compartment-id database-id from-json help id page sql-identifier time-interval-end time-interval-start'
        'opsi database-insights summarize-sql-statistics' = 'analysis-time-interval category compartment-id database-id database-time-pct-greater-than database-type defined-tag-equals defined-tag-exists freeform-tag-equals freeform-tag-exists from-json help host-name id limit page sort-by sort-order sql-identifier time-interval-end time-interval-start'
        'opsi database-insights summarize-sql-statistics-time-series' = 'analysis-time-interval compartment-id database-id defined-tag-equals defined-tag-exists freeform-tag-equals freeform-tag-exists from-json help host-name id page sql-identifier time-interval-end time-interval-start'
        'opsi database-insights summarize-sql-statistics-time-series-by-plan' = 'analysis-time-interval compartment-id database-id from-json help id page sql-identifier time-interval-end time-interval-start'
        'opsi database-insights update-autonomous-db' = 'database-insight-id defined-tags force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi database-insights update-em-external-db' = 'database-insight-id defined-tags force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi database-insights update-macs-external-db' = 'database-insight-id defined-tags force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi enterprise-manager-bridges change' = 'compartment-id enterprise-manager-bridge-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi enterprise-manager-bridges create' = 'compartment-id defined-tags description display-name freeform-tags from-json help max-wait-seconds object-storage-bucket-name wait-for-state wait-interval-seconds'
        'opsi enterprise-manager-bridges delete' = 'enterprise-manager-bridge-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi enterprise-manager-bridges get' = 'enterprise-manager-bridge-id from-json help'
        'opsi enterprise-manager-bridges list' = 'all compartment-id display-name from-json help id lifecycle-state limit page page-size sort-by sort-order'
        'opsi enterprise-manager-bridges list-importable-enterprise-manager-entities' = 'all enterprise-manager-bridge-id from-json help limit page page-size'
        'opsi enterprise-manager-bridges update' = 'defined-tags description display-name enterprise-manager-bridge-id force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi host-insights change' = 'compartment-id from-json help host-insight-id if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi host-insights create-macs-external-host' = 'compartment-id defined-tags freeform-tags from-json help management-agent-id max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi host-insights delete' = 'force from-json help host-insight-id if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi host-insights disable' = 'from-json help host-insight-id if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi host-insights enable-macs-external-host' = 'from-json help host-insight-id if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi host-insights get' = 'from-json help host-insight-id'
        'opsi host-insights ingest-host-configuration' = 'from-json help id if-match items'
        'opsi host-insights ingest-host-metrics' = 'from-json help id if-match items'
        'opsi host-insights list' = 'all compartment-id from-json help host-type id lifecycle-state limit page page-size platform-type sort-by sort-order status'
        'opsi host-insights list-hosted-entities' = 'all analysis-time-interval compartment-id from-json help id limit page page-size platform-type sort-by sort-order time-interval-end time-interval-start'
        'opsi host-insights summarize-host-insight-resource-capacity-trend' = 'analysis-time-interval compartment-id defined-tag-equals defined-tag-exists freeform-tag-equals freeform-tag-exists from-json help id page platform-type resource-metric sort-by sort-order time-interval-end time-interval-start utilization-level'
        'opsi host-insights summarize-host-insight-resource-forecast-trend' = 'analysis-time-interval compartment-id confidence defined-tag-equals defined-tag-exists forecast-days forecast-model freeform-tag-equals freeform-tag-exists from-json help id page platform-type resource-metric statistic time-interval-end time-interval-start utilization-level'
        'opsi host-insights summarize-host-insight-resource-statistics' = 'analysis-time-interval compartment-id defined-tag-equals defined-tag-exists forecast-days freeform-tag-equals freeform-tag-exists from-json help id insight-by limit page percentile platform-type resource-metric sort-by sort-order time-interval-end time-interval-start'
        'opsi host-insights summarize-host-insight-resource-usage' = 'analysis-time-interval compartment-id defined-tag-equals defined-tag-exists freeform-tag-equals freeform-tag-exists from-json help id page percentile platform-type resource-metric time-interval-end time-interval-start'
        'opsi host-insights summarize-host-insight-resource-usage-trend' = 'analysis-time-interval compartment-id defined-tag-equals defined-tag-exists freeform-tag-equals freeform-tag-exists from-json help id page platform-type resource-metric sort-by sort-order time-interval-end time-interval-start'
        'opsi host-insights summarize-host-insight-resource-utilization-insight' = 'analysis-time-interval compartment-id defined-tag-equals defined-tag-exists forecast-days freeform-tag-equals freeform-tag-exists from-json help id page platform-type resource-metric time-interval-end time-interval-start'
        'opsi host-insights update-macs-external-host' = 'defined-tags force freeform-tags from-json help host-insight-id if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi work-requests get' = 'from-json help work-request-id'
        'opsi work-requests list' = 'all compartment-id from-json help limit page page-size'
    }
    return $ociCommandsToLongParams
}

function GetOciCommandsToShortParams_opsi() {
    $ociCommandsToShortParams = @{
        'opsi database-insights change' = '? c h'
        'opsi database-insights create-em-external-db' = '? c h'
        'opsi database-insights delete' = '? h'
        'opsi database-insights disable' = '? h'
        'opsi database-insights enable-em-external-db' = '? h'
        'opsi database-insights get' = '? h'
        'opsi database-insights ingest-database-configuration' = '? h'
        'opsi database-insights ingest-sql-bucket' = '? c h'
        'opsi database-insights ingest-sql-plan-lines' = '? c h'
        'opsi database-insights ingest-sql-text' = '? c h'
        'opsi database-insights list' = '? c h'
        'opsi database-insights list-database-configurations' = '? c h'
        'opsi database-insights list-sql-plans' = '? c h'
        'opsi database-insights list-sql-searches' = '? c h'
        'opsi database-insights list-sql-texts' = '? c h'
        'opsi database-insights summarize-database-insight-resource-capacity-trend' = '? c h'
        'opsi database-insights summarize-database-insight-resource-forecast-trend' = '? c h'
        'opsi database-insights summarize-database-insight-resource-statistics' = '? c h'
        'opsi database-insights summarize-database-insight-resource-usage' = '? c h'
        'opsi database-insights summarize-database-insight-resource-usage-trend' = '? c h'
        'opsi database-insights summarize-database-insight-resource-utilization-insight' = '? c h'
        'opsi database-insights summarize-database-insight-tablespace-usage-trend' = '? c h'
        'opsi database-insights summarize-sql-insights' = '? c h'
        'opsi database-insights summarize-sql-plan-insights' = '? c h'
        'opsi database-insights summarize-sql-response-time-distributions' = '? c h'
        'opsi database-insights summarize-sql-statistics' = '? c h'
        'opsi database-insights summarize-sql-statistics-time-series' = '? c h'
        'opsi database-insights summarize-sql-statistics-time-series-by-plan' = '? c h'
        'opsi database-insights update-autonomous-db' = '? h'
        'opsi database-insights update-em-external-db' = '? h'
        'opsi database-insights update-macs-external-db' = '? h'
        'opsi enterprise-manager-bridges change' = '? c h'
        'opsi enterprise-manager-bridges create' = '? c h'
        'opsi enterprise-manager-bridges delete' = '? h'
        'opsi enterprise-manager-bridges get' = '? h'
        'opsi enterprise-manager-bridges list' = '? c h'
        'opsi enterprise-manager-bridges list-importable-enterprise-manager-entities' = '? h'
        'opsi enterprise-manager-bridges update' = '? h'
        'opsi host-insights change' = '? c h'
        'opsi host-insights create-macs-external-host' = '? c h'
        'opsi host-insights delete' = '? h'
        'opsi host-insights disable' = '? h'
        'opsi host-insights enable-macs-external-host' = '? h'
        'opsi host-insights get' = '? h'
        'opsi host-insights ingest-host-configuration' = '? h'
        'opsi host-insights ingest-host-metrics' = '? h'
        'opsi host-insights list' = '? c h'
        'opsi host-insights list-hosted-entities' = '? c h'
        'opsi host-insights summarize-host-insight-resource-capacity-trend' = '? c h'
        'opsi host-insights summarize-host-insight-resource-forecast-trend' = '? c h'
        'opsi host-insights summarize-host-insight-resource-statistics' = '? c h'
        'opsi host-insights summarize-host-insight-resource-usage' = '? c h'
        'opsi host-insights summarize-host-insight-resource-usage-trend' = '? c h'
        'opsi host-insights summarize-host-insight-resource-utilization-insight' = '? c h'
        'opsi host-insights update-macs-external-host' = '? h'
        'opsi work-requests get' = '? h'
        'opsi work-requests list' = '? c h'
    }
    return $ociCommandsToShortParams
}